import java.util.LinkedHashMap;

/**
 * Lab #5
 * CS 2334, Section SECTION NUMBER GOES HERE
 * DATE GOES HERE
 * <p>
 * Each object of this class represents a state.
 * </p>
 * @version 1.0
 *
 */
public class State {
	private String name;
	private LinkedHashMap<String, City> cityMap;

	public State (){
		this.name = "";
		this.cityMap = new LinkedHashMap<String, City>();
	}
	
	public State (String name) {
		this.name = name;
		this.cityMap = new LinkedHashMap<String, City>();
	}

	/**
	 * @param name
	 * @param cityMap
	 */
	public State(String name, LinkedHashMap<String, City> cityMap) {
		this.name = name;
		this.cityMap = cityMap;
	}

	/**
	 * @return the state name
	 */
	public String getName() {
		return name;
	}

	/**
	 * @param name the name of the state to set
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * @return an array of the cities in the cityMap
	 */
	public City[] getCityArray() {
		City[] templateCityArray = new City[1];
		return cityMap.values().toArray(templateCityArray);
	}

	/**
	 * @param cityMap the collection of cities to set
	 */
	public void setCityMap(LinkedHashMap<String, City> cityMap) {
		this.cityMap = cityMap;
	}
	
	/**
	 * @param city to add to the cityMap
	 */
	public void addCity(City city) {
		this.cityMap.put(city.getName(), city);
	}
	
	/**
	 * Clears the collection of city
	 */
	public void clearCities() {
		this.cityMap = new LinkedHashMap<String, City>();
	}
}